<template>
  <div class="content mt-10 w-full">
    <h1 class="text-center font-bold">{{ question.libelle }}</h1>
    <form class="w-full my-10">
      <div class="w-full flex flex-col justify-center items-center">
        <div
          class="w-1/4 p-8 flex justify-center items-center border border-black rounded mb-10 cursor-pointer"
          :class="{
            'bg-green-700': submitted && checkedResponse === question.reponse[0].id && goodResponse,
            'bg-red-700': submitted && checkedResponse === question.reponse[0].id && !goodResponse
          }"
        >
          <input type="radio" :id="question.reponse[0].id" :value="question.reponse[0].id" v-model="checkedResponse">
          <label
            class="ml-2 font-bold text-lg"
            :class="{ 'text-white': submitted && checkedResponse === question.reponse[0].id }"
            :for="question.reponse[0].id">
            {{ question.reponse[0].libelle }}
          </label>
        </div>
        <div
          class="w-1/4 p-8 flex justify-center items-center border border-black rounded mb-10 cursor-pointer"
          :class="{
            'bg-green-700': submitted && checkedResponse === question.reponse[1].id && goodResponse,
            'bg-red-800': submitted && checkedResponse === question.reponse[1].id && !goodResponse
          }"
        >
          <input type="radio" :id="question.reponse[1].id" :value="question.reponse[1].id" v-model="checkedResponse">
          <label
            class="ml-2 font-bold text-lg"
            :class="{ 'text-white': submitted && checkedResponse === question.reponse[1].id }"
            :for="question.reponse[1].id">
            {{ question.reponse[1].libelle }}
          </label>
        </div>
        <div
          class="w-1/4 p-8 flex justify-center items-center border border-black rounded mb-10 cursor-pointer"
          :class="{
            'bg-green-700': submitted && checkedResponse === question.reponse[2].id && goodResponse,
            'bg-red-700': submitted && checkedResponse === question.reponse[2].id && !goodResponse
          }"
        >
          <input type="radio" :id="question.reponse[2].id" :value="question.reponse[2].id" v-model="checkedResponse">
          <label
            class="ml-2 font-bold text-lg"
            :class="{ 'text-white': submitted && checkedResponse === question.reponse[2].id }"
            :for="question.reponse[2].id">
            {{ question.reponse[2].libelle }}
          </label>
        </div>
        <div
          class="w-1/4 p-8 flex justify-center items-center border border-black rounded mb-10 cursor-pointer"
          :class="{
            'bg-green-700': submitted && checkedResponse === question.reponse[3].id && goodResponse,
            'bg-red-700': submitted && checkedResponse === question.reponse[3].id && !goodResponse
          }"
        >
          <input type="radio" :id="question.reponse[3].id" :value="question.reponse[3].id" v-model="checkedResponse">
          <label
            class="ml-2 font-bold text-lg"
            :class="{ 'text-white': submitted && checkedResponse === question.reponse[3].id }"
            :for="question.reponse[3].id">
            {{ question.reponse[3].libelle }}
          </label>
        </div>
      </div>
        <div class="form-submit">
          <button
            v-if="!submitted"
            class="btn btn-red uppercase my-5"
            @click.prevent="handleValidate">
            Vérifier
          </button>
          <button
            v-else-if="!finishedGame"
            class="btn btn-red uppercase my-5"
            @click.prevent="handleNextQuestion">
            Question suivante
          </button>
          <button
            v-else
            class="btn btn-red uppercase my-5"
            @click.prevent="handleEnd">
            Terminer la partie
          </button>
        </div>
    </form>
  </div>
</template>

<script>

import { required, email, numeric } from 'vuelidate/lib/validators'

export default {
  name: "Question",

  data: function () {
    return {
      checkedResponse: '',
      submitted: false,
      goodResponse : false
    }
  },


  computed: {
    question() {
      return this.$store.state.games.questions[this.currentQuestionPosition]
    },

    currentQuestionPosition() {
      return this.$store.state.games.current.currentQuestionPosition
    },

    finishedGame() {
      return this.currentQuestionPosition + 1 == this.$store.state.games.current.questionsNumber
    }
  },

  methods: {
    responseIsGood() {
      const correctResponseIndex = this.question.reponse.findIndex((value) => {
        return value.bonne_reponse
      })
      if(this.question.reponse[correctResponseIndex].id === this.checkedResponse) {
        this.goodResponse = true
        this.$store.commit('INCREMENT_SCORE')
      }
    },

    async handleValidate () {
      if(this.checkedResponse) {
        this.submitted = true
      }
      this.responseIsGood()
    },

    handleNextQuestion() {
      this.submitted = false
      this.goodResponse = false
      this.checkedResponse = ''
      this.$store.commit('INCREMENT_QUESTION_POSITION')
    },

    async handleEnd() {
      await this.$store.dispatch('setScore')
      await this.$router.push({ name: 'score' })
    }
  },

  validations: {
    checkedResponse: {
      required
    }
  },
}
</script>

<style scoped>

</style>
